Форум программистов, компьютерный форум, киберфорум
SolidWorks
Войти
Регистрация
Восстановить пароль
 
Рейтинг 4.80/5: Рейтинг темы: голосов - 5, средняя оценка - 4.80
0 / 0 / 0
Регистрация: 20.09.2016
Сообщений: 9
1

Невозможно привести COM-объект типа "System.__ComObject" к интерфейсному типу "SolidWorks.Interop.sldworks.DrawingDoc"

05.12.2017, 11:11. Просмотров 1007. Ответов 1
Метки нет (Все метки)

Здравствуйте! Возникла проблема при программировании макроса для Solidworks 2012 в Visual Studio на C#. При запуске проекта начало кода выполняется нормально, но на строке swDrawing = (DrawingDoc)Part; выскакивает данная ошибка:

Невозможно привести COM-объект типа "System.__ComObject" к интерфейсному типу "SolidWorks.Interop.sldworks.DrawingDoc"


Ссылки добавляла как на COM вкладке (SldWorks 2012 Type Library, SolidWorks 2012 Constant type library) так и через Обзор непосредственно подключала библиотеки для Solidworks 2012: SolidWorks.Interop.sldworks.dll, SolidWorks.Interop.swconst.dll, SolidWorks.Interop.swcommands.dll.

И через командную строку пробовала выполнять: C:\Windows\Microsoft.NET\Framework\v4.0.30319\regtlibv12.exe "C:\Program Files\SolidWorks Corp\SolidWorks (3)\sldworks.tlb"

Невозможно привести COM-объект типа "System.__ComObject" к интерфейсному типу "SolidWorks.Interop.sldworks.DrawingDoc"


Ничего не помогло. На компьютере установлено несколько версий Solidworks (2012, 2016 и 2017). Ниже написан код программы:

C#
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
85
86
87
88
89
90
91
92
93
94
95
96
97
98
99
100
101
102
103
104
105
106
107
108
109
110
111
112
113
114
115
116
117
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using SolidWorks.Interop.sldworks;
using SolidWorks.Interop.swcommands;
using SolidWorks.Interop.swconst;
using System.IO;
 
namespace CreateDrawing
{
    public partial class Form1 : Form
    {
        SldWorks swApp;
        ModelDoc2 Part = default(ModelDoc2);
 
        public Form1()
        {
            InitializeComponent();
        }
 
        //функция проверки открытия файла
        public bool IsFileOpen(string path)
        {
            if (string.IsNullOrEmpty(path))
                throw new ArgumentException("'path' cannot be null or empty.", "path");
 
            try
            {
                using (var stream = new FileStream(path, FileMode.Open, FileAccess.Read)) { }
            }
            catch (IOException)
            {
                return true;
            }
 
            return false;
        }
        
        private void button2_Click(object sender, EventArgs e)
        {
            Close();
        }
 
        private void button1_Click(object sender, EventArgs e)
        {
            string User;
            User = System.Environment.UserName;
 
            //запускает SolidWorks2012
            //object processSW = System.Activator.CreateInstance(System.Type.GetTypeFromProgID("SldWorks.Application"));
            Guid myGuid1 = new Guid("B4875E89-91F6-4124-BB63-2539727E98FA"); //GUID для Solidworks 2012
            object processSW = System.Activator.CreateInstance(System.Type.GetTypeFromCLSID(myGuid1));
 
            swApp = (SldWorks)processSW;
            swApp.Visible = true;
 
            int longstatus = 0;
            int longwarnings = 0;
 
            try
            {
                Part = (ModelDoc2)swApp.ActiveDoc;
 
                if (IsFileOpen(@"C:\IM\IMWork\Направляющий аппарат с торовой поверхностью.SLDPRT"))
                {
                    goto a;
                }
                else
                {
                    Part = (ModelDoc2)swApp.OpenDoc6(@"C:\IM\IMWork\Направляющий аппарат с торовой поверхностью.SLDPRT", 1, 0, "", ref longstatus, ref longwarnings);
                    goto a;
                };
 
                a:ModelView swModelView = default(ModelView);
                DrawingDoc swDrawing = default(DrawingDoc);
                bool boolstatus;
                SelectionMgr swSelMgr = default(SelectionMgr);
                SolidWorks.Interop.sldworks.View myView = default(SolidWorks.Interop.sldworks.View);
                Object vScaleRatio;
 
                Part = (ModelDoc2)swApp.ActiveDoc;
                swModelView = (ModelView)Part.ActiveView;
                swDrawing = (DrawingDoc)Part; //ошибка в данной строке кода, переход на catch
 
                swSelMgr = (SelectionMgr)Part.SelectionManager;
                Part = swApp.NewDocument(@"C:\ProgramData\SolidWorks\SolidWorks 2012\templates\gost-part drw.drwdot", 0, 0, 0);
 
                myView = swDrawing.CreateDrawViewFromModelView3(@"C:\IM\IMWork\Направляющий аппарат с торовой поверхностью.SLDPRT", "Слева", 0.13835806060864, 8.53251696525708E-02, 0);
                boolstatus = Part.Extension.SelectByID2("Чертежный вид1", "DRAWINGVIEW", 0, 0, 0, false, 0, null, 0);
                boolstatus = Part.ActiveView("Чертежный вид1");
                vScaleRatio = myView.ScaleRatio;
                myView.ScaleDecimal = myView.ScaleDecimal * 5;
                Part.EditRebuild3();
                myView = swDrawing.CreateUnfoldedViewAt3(-0.210437678570781, 8.53251696525708E-02, 0, false);
                Part.ClearSelection2(true);
                boolstatus = Part.Extension.SelectByID2("Чертежный вид1", "DRAWINGVIEW", 0, 0, 0, false, 0, null, 0);
                myView = swDrawing.CreateUnfoldedViewAt3(0.516477335382791, 8.53251696525708E-02, 0, false);
                Part.ClearSelection2(true);
                Part.ViewZoomtofit2();
                longstatus = Part.SaveAs3(@"C:\IM\IMWork\Направляющий аппарат с торовой поверхностью.DWG", 0, 2);
 
                MessageBox.Show(@"Чертеж был успешно построен и сохранен в папку C:\IM\IMWORK\Направляющий аппарат с торовой поверхностью.DWG");
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message);
            }
        }
 
    }
}
Буду очень благодарна за помощь от более опытных программистов, кто возможно сталкивался с данной проблемой.
0
Programming
Эксперт
94731 / 64177 / 26122
Регистрация: 12.04.2006
Сообщений: 116,782
05.12.2017, 11:11
Ответы с готовыми решениями:

Ошибка: "невозможно создать этот элемент вытягивания из-за геометрических условий"
Иногда SW отказывается делать вытянутую бобышку (название-то какое! )) ) вообще без причин!...

"Прочностной анализ" в программе "Компас 3D"
День добрый. Подскажите, пожалуйста, каким образом, при выполнении "Прочностного анализа"...

Что делать с ошибкой "Создание сетки не удалось. Прерывание анализа" в Solid Works
Добрый день! Необходимо исследовать деформацию и распределение напряжений в чугунной детали под...

Давным-давно пора создать в теме "САПР" несколько подтем, содержащих не только AutoCad
Эта идея возникла не на пустом месте и зрела много лет. Прошу для начала вникнуть в ее причины: ...

1
-21 / 0 / 0
Регистрация: 29.09.2018
Сообщений: 27
04.11.2018, 21:51 2
А какая версия Windows?
0
IT_Exp
Эксперт
87844 / 49110 / 22898
Регистрация: 17.06.2006
Сообщений: 92,604
04.11.2018, 21:51

Заказываю контрольные, курсовые, дипломные и любые другие студенческие работы здесь.

Невозможно привести COM-объект типа "System.__ComObject" к интерфейсному типу "Microsoft.Office.Interop.Excel.Worksheet"
Доброго времени суток. Суть проблемы такова: написал программку добавил функцию сохранения в...

Невозможно привести COM-объект типа "System.__ComObject" к интерфейсному типу "ADODB.Connection"
Создал приложение, но при запуске на другом компе выходит ошибка (как решить?): Подробная...

Ошибка: "Не удалось привести типа объекта "System.Windows.Forms.TextBox" к типу "System.IConvertible".""
Программа выдает такой текст: "System.InvalidCastException: "Не удалось привести типа объекта...

Ошибка "Не удалось привести тип объекта "System.Data.DataRowView" к типу "System.IConvertible""
Здравствуйте,столкнулся с некой ошибкой.Привязал данные к comboBox пытаюсь выполнить процедуру...


Искать еще темы с ответами

Или воспользуйтесь поиском по форуму:
2
Ответ Создать тему
Опции темы

КиберФорум - форум программистов, компьютерный форум, программирование
Powered by vBulletin® Version 3.8.9
Copyright ©2000 - 2020, vBulletin Solutions, Inc.